from sqlalchemy import create_engine, MetaData, Table, insert, select,update,delete,text
from sqlalchemy.sql import and_, or_
from core import app
import json

engine = create_engine(app.config['DATABASE_URI'],future=True)
engine_fk = create_engine(app.config['DATABASE_URI_FK'],future=True)

class FoodSessionModel():
	def __init__(self):
		try:
			self.meta = MetaData()
			self.fc_sessions = Table("fc_sessions", self.meta, autoload_with=engine_fk)
			self.fc_users = Table("fc_users", self.meta,  autoload_with=engine_fk)     
		except Exception as e:
			print(e)

	def getfcConf(self,conf_id,conf_key,current_dt) :
		with engine.connect() as conn:
			stmt = text("select * from conference where  conf_id ="+str(conf_id)+" and conf_key ='"+conf_key+"' and '"+current_dt+"'  between conf_start_time and conf_end_time ;")
			# stmt = text("select * from conference where  conf_id ="+str(conf_id)+" and conf_key ='"+conf_key+"'  ;")
			result = conn.execute(stmt)
			result = result.one_or_none()
			return dict(result._mapping) if result else None
	
	# get conf data start
	def getFcConfData(self,conf_id,conf_key) :
		with engine.connect() as conn:
			stmt = text("select * from conference where conf_id ="+str(conf_id)+" and conf_key = '"+conf_key+"';")
			result = conn.execute(stmt)
			result = result.one_or_none()
			return dict(result._mapping) if result else None 

	# get conf data end
	def insert_fcbodata_and_getdata(self,data,conf_id,conf_key):
		with engine_fk.connect() as conn:
			result = conn.execute(self.fc_sessions.insert(), data)
			conn.commit()

			stmt = text("SELECT f.session_id,f.session_name,f.session_key,f.start_time,f.end_time,f.is_active from fc_sessions f where conf_id ="+str(conf_id)+" and conf_key ='"+conf_key+"' ;")
			result = conn.execute(stmt).all()
			results = [dict(r._mapping) for r in result] if result else None
			return results
		

	def getFCBOSessionData(self,conf_id,conf_key):
		with engine_fk.connect() as conn:
			stmt    = text("SELECT f.session_id,f.session_name,f.session_key,f.start_time,f.end_time,f.is_active from fc_sessions f where conf_id ="+str(conf_id)+" and conf_key ='"+conf_key+"' ;")
			result  = conn.execute(stmt).all()
			results = [dict(r._mapping) for r in result] if result else None
			return results		

	def edit_fcbo(self,session_id):
		with engine_fk.connect() as conn:
			stmt = select([self.fc_sessions]).where(self.fc_sessions.c.session_id.in_([session_id]))
			result = conn.execute(stmt)
			result = result.one_or_none()
			return dict(result._mapping) if result else None 

	def update_fcbo_and_getdata(self,data_for_update,session_id,conf_id,conf_key):
		with engine_fk.connect() as conn:
			stmt = self.fc_sessions.update().where(self.fc_sessions.c.session_id.in_([session_id])).values(data_for_update)
			conn.execute(stmt)
			conn.commit()
			stmt_2 = text("SELECT f.session_id,f.session_name,f.session_key,f.start_time,f.end_time,f.is_active from fc_sessions f where conf_id ="+str(conf_id)+" and conf_key ='"+conf_key+"' ;")
			result  = conn.execute(stmt_2).all()
			results = [dict(r._mapping) for r in result] if result else None
			return results

	def delete_fcbo_session_index(self,session_id):
		with engine_fk.connect() as conn:
			stmt = self.fc_sessions.delete().where(self.fc_sessions.c.session_id.in_([session_id]))
			conn.execute(stmt)
			conn.commit()

			stmt_2 = text("SELECT f.session_id,f.session_name,f.session_key,f.start_time,f.end_time,f.is_active from fc_sessions f ;")
			result = conn.execute(stmt_2).all()
			results = [dict(r._mapping) for r in result] if result else None
			return results

	def getDataByUsername(self,user_name):
		with engine_fk.connect() as conn:
			stmt = text("select  * from fc_users where user_name  = '"+user_name+"' ;")
			result = conn.execute(stmt)
			result = result.one_or_none()
			return dict(result._mapping) if result else None
		
	def updateFCLoginTime(self,fc_user_id,current_dt):
		with engine_fk.connect() as conn:
			stmt = text("update fc_users set login_at = '"+current_dt+"'  where fc_user_id  = "+str(fc_user_id)+" ;")
			result = conn.execute(stmt)
			conn.commit()
			return "login time updated."

	